;tortue de type refuge
;a completer
breed [refuge]

;tortue de type alpiniste
breed [alpiniste]

patches-own [
  ;hauteur du terrain en pxls
  elevation
  ;hauteur reele du terrain en m
  height
  ;pente du terrain
  slope
  ;niveau de neige
  snow_level
  ;nombre de fois que le patch à été pris dans une avalanche
  ;a completer
  danger
]

alpiniste-own[
  ;variables qui stockent la dernière position et la dernière altitude de l'alpiniste
  last_height
  last_xcor
  last_ycor
]

globals [
  ;pente de declenchement
  trigger_slope
  ;couleurs de fond de la carte
  colors
]

to Load
  ca
  
  ;associe initialise la variable elevation de chaque patch d'après
  ;la hauteur du point correspondant dans le .data
  ;  
  file-open name
  let patch-elevations file-read
  file-close
  (foreach sort patches patch-elevations [ 
    ask ?1 [set elevation ?2]
  ])
  
  ;rempli la liste colors avec les valeurs du fichier "color_scale.data"
  set colors []
  file-open "color_scale.data"
  foreach n-values 256 [?] [
    set colors lput (rgb file-read file-read file-read) colors
  ]
  file-close
  
  ;initialisation des patches
  ask patches[
    set pcolor black
    ;initialisation de la hauteur reele
    ; à completer
    set height (10 / 3 * elevation + 1500)
  ]
  
  ask patches[
    ;initialisation de la pente (slope)
    ; à completer
    set slope ( sqrt (variance [height] of neighbors) / 10) 
    color_patch
  ]
  
  ;creation et placement du refuge
  ;a completer
  create-refuge 1 [
    setxy -2 -13
    set size 6
    set shape "house"
    set color red
  ]

  ;creation et placement aleatoire des alpinistes
  ;a completer  
  create-alpiniste 50 [
    set size 3
    setxy random-xcor random-ycor
    set shape "person"
    set last_xcor xcor
    set last_ycor ycor
    set last_height [height] of patch-here
  ]

end

to go
   ;coloriage des patches
   ask patches[color_patch]
   ;on fait neiger
   snow
   ;a chaque tour, on lance un déclenchement naturel d'avalanche sur l'un des patch
   ask one-of patches [trigger_avalanche]
   ;bouger les alpinistes
   move_alpinistes
end

to move_alpinistes
  ;deplacement des alpinistes
  ;a completer
  ask alpiniste[
    ;calcul des chutes et des glissades
    let chute sqrt(([height] of patch-here - last_height) ^ 2)
    let glisse sqrt((xcor - last_xcor) ^ 2 + (ycor - last_ycor) ^ 2)
    
    if chute > 100 or glisse > 20 [ die ]
    
    right ((random 90) - 45)
    ;set heading towards one-of refuge 
    forward 1
    
    set last_xcor xcor
    set last_ycor ycor
    set last_height [height] of patch-here
  ]
end

to trigger_avalanche
   ;condition de declenchement
   ;a completer
    if slope > pente / 100 and snow_level > 8 [
      ask neighbors [set pcolor blue]
      set pcolor red
      wait 1
      avalanche (lput self []) 
    ]
end



;lance une avalanche en demandant aux patches du dessous s'ils s'effondrent ou non ..
to avalanche [ pset ]
  ;tmp est une liste vide
  let tmp []
  ;parcours des éléments de la liste pset
  foreach pset [
    ;? est l'élément courant de pset, dans notre cas c'est un patch
    ask ?[
      let inf []
      ;inf contient les patches voisins situés à des altitudes inférieurs
      ;a completer
      set inf neighbors with [height < [height] of myself]
      
      let hlevel 0
      ;somme des différences d'altitude par rapport aux patchs inférieurs
      ;a completer
      ask inf[set hlevel (hlevel + ([height] of myself - height))]
      
      ask inf [
        ;nouveau niveau de neige des patches inférieurs
        ;a completer
        set snow_level snow_level + ((0.8 *([snow_level] of myself))*(([height] of myself - height) / hlevel))
        
        ;faut il ajouter le patch inférieur dans la suite de l'avalanche
        ;a completer
        if (member? self tmp = false and slope * snow_level > 4)[
          set tmp lput self tmp
        ]
        set pcolor white
      ]
      
      ;il ne reste pluq que 20% de la neige sur le patch courant
      set snow_level 0.2 * snow_level
      
      ;augmentation du dager de la pente
      ;a completer
      set danger (danger + 1)
      
      ;si des alpinistes sont sur le terrain, ils se distribuents vers les inférieurs
      ;a completer
      if count inf > 0 [ ask alpiniste-here[move-to one-of inf] ]
      
      ;si on touche le refuge, celui ci est detruit
      ;a completer
      ask refuge-here [ die ]
      
      color_patch
    ]
  ]
  ;appel recursif tant que tmp n'est pas vide..
  if ((length tmp > 0))[ avalanche tmp ]
end

;fait neiger
to snow
  ;faire neiger sur neige * 200 patches
  ;a completer
  ask n-of (neige * 200) patches[
    if height > iso_0 [
      set snow_level snow_level + sqrt ( (height - iso_0) / 850)
    ]
  ]
  
  ;faire fondre sur tout les patches sous l'iso
  ;a completer
  ask patches [
    if height < iso_0 and snow_level > 0 [
      set snow_level snow_level - sqrt ( (iso_0 - height) / (850 * 10) )
    ]
  ]
end

to reset_snow
  ask patches [ set snow_level 0 ]
end

;coloriage de la carte
to color_patch
  ;par defaut, dessiner le patch à la couleur sur la carte
  ; à completer
  set pcolor item elevation colors
  
  ;si on affiche la neige
  ;a completer
  if dneige = true and snow_level > .1 [blend_color white (snow_level / 8)]
  
  ;si on affiche les pentes dangeureuses
  ;a completer
  if dpente = true and slope > 0.01 * pente [blend_color violet 0.5]
  
  ;si on affiche la courbe iso°
  ;a completer
  if diso = true [ 
     if height > iso_0 - 5 and height < iso_0 + 5 [ blend_color red .7 ]
  ]
  
  ;si on affiche les patches dangereux
  ;a completer
  if ddanger = true [ 
     if danger > 1 or slope > 0.01 * pente [ blend_color red ((danger + 2) / 10) ]
  ]
end


;effectue le melange de 2 couleurs entre la couleur d'origine et dest_color
;à hauteur de (prop*100)% .. s'appelle depuis patches
to blend_color [dest_color prop]
  let list_dest []
  let list_orig []
  let list_tmp []
  if prop > 1 [set prop 1]
  if prop < 0 [set prop 0]
  ifelse is-list? dest_color [set list_dest dest_color][set list_dest extract-rgb dest_color]
  ifelse is-list? pcolor [set list_orig pcolor][set list_orig extract-rgb pcolor]

  set list_tmp lput ( ( ( (item 0 list_dest) / 255 * (prop) + (item 0 list_orig) / 255 * (1 - prop) ) ) * 255 ) list_tmp
  set list_tmp lput ( ( ( (item 1 list_dest) / 255 * (prop) + (item 1 list_orig) / 255 * (1 - prop) ) ) * 255 ) list_tmp
  set list_tmp lput ( ( ( (item 2 list_dest) / 255 * (prop) + (item 2 list_orig) / 255 * (1 - prop) ) ) * 255 ) list_tmp
  
  set pcolor rgb (item 0 list_tmp) (item 1 list_tmp) (item 2 list_tmp)
end
@#$#@#$#@
GRAPHICS-WINDOW
317
10
841
555
128
128
2.0
1
10
1
1
1
0
0
0
1
-128
128
-128
128
0
0
0
ticks

CC-WINDOW
5
569
850
664
Command Center
0

CHOOSER
25
15
245
60
name
name
"regular.data" "mountain.data" "mountain2.data" "couloir.data" "couloir2.data"
1

BUTTON
25
60
135
93
NIL
Load
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
25
100
155
133
pente
pente
0
150
60
1
1
%
HORIZONTAL

BUTTON
135
60
245
93
NIL
Go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL

SWITCH
155
100
245
133
Dpente
Dpente
1
1
-1000

SLIDER
25
135
155
168
neige
neige
0
50
38
1
1
cm/h
HORIZONTAL

SWITCH
155
135
245
168
Dneige
Dneige
0
1
-1000

BUTTON
245
135
300
168
raz
Reset_snow
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL

SLIDER
25
170
155
203
iso_0
iso_0
1500
2353
1804
1
1
m
HORIZONTAL

SWITCH
155
170
245
203
Diso
Diso
0
1
-1000

SWITCH
155
205
276
238
Ddanger
Ddanger
1
1
-1000

@#$#@#$#@
WHAT IS IT?
-----------
This section could give a general understanding of what the model is trying to show or explain.


HOW IT WORKS
------------
This section could explain what rules the agents use to create the overall behavior of the model.


HOW TO USE IT
-------------
This section could explain how to use the model, including a description of each of the items in the interface tab.


THINGS TO NOTICE
----------------
This section could give some ideas of things for the user to notice while running the model.


THINGS TO TRY
-------------
This section could give some ideas of things for the user to try to do (move sliders, switches, etc.) with the model.


EXTENDING THE MODEL
-------------------
This section could give some ideas of things to add or change in the procedures tab to make the model more complicated, detailed, accurate, etc.


NETLOGO FEATURES
----------------
This section could point out any especially interesting or unusual features of NetLogo that the model makes use of, particularly in the Procedures tab.  It might also point out places where workarounds were needed because of missing features.


RELATED MODELS
--------------
This section could give the names of models in the NetLogo Models Library or elsewhere which are of related interest.


CREDITS AND REFERENCES
----------------------
This section could contain a reference to the model's URL on the web if it has one, as well as any other necessary credits or references.
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 4.0.2
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
